﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;
using Telerik.Windows.Zip;
using Telerik.Windows.Persistence;

namespace WpfApplication3
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		public Window1()
		{
			InitializeComponent();
		}
		private Stream stream;
		private MyWindow win;
		private MemoryStream compressedStream;

		private void Open(object sender, RoutedEventArgs e)
		{
			win = new MyWindow();
			win.Show();
		}

		private void Load(object sender, RoutedEventArgs e)
		{
			ZipPackage package = ZipPackage.Open(compressedStream);

			PersistenceManager manager = new PersistenceManager();
			stream.Position = 0L;

			MemoryStream decompressedStream = new MemoryStream();

			byte[] buffer = new byte[10024];
			int read;
			Stream inputStream = package.ZipPackageEntries[0].OpenInputStream();
			while ((read = inputStream.Read(buffer, 0, buffer.Length)) > 0)
			{
				decompressedStream.Write(buffer, 0, read);
			}
	
			decompressedStream.Position = 0;
			manager.Load(win, decompressedStream);
		}

		private void Save(object sender, RoutedEventArgs e)
		{
			PersistenceManager manager = new PersistenceManager();
			stream = manager.Save(win);

			compressedStream = new MemoryStream();
			ZipPackage package = ZipPackage.Create(compressedStream);
			package.AddStream(stream, "WindowPeristedData");

			//save compressedStream in your database
		}
	}
}
